diff --git a/enrol/authorize/authorizenet.class.php b/enrol/authorize/authorizenet.class.php
index 9181964..08fb8e5 100644
--- a/enrol/authorize/authorizenet.class.php
+++ b/enrol/authorize/authorizenet.class.php
@@ -1,4 +1,31 @@
 <?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize enrolment plugin.
+ *
+ * This plugin allows you to set up paid courses, using authorize.net.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
 
 if (!defined('MOODLE_INTERNAL')) {
     die('Direct access to this script is forbidden.');
@@ -27,14 +54,13 @@ class AuthorizeNet
      */
     public static function getsettletime($time)
     {
-        global $CFG;
+        $mconfig = get_config('enrol_authorize');
 
-        $cutoff = intval($CFG->an_cutoff);
-        $mins = $cutoff % 60;
-        $hrs = ($cutoff - $mins) / 60;
-        $cutofftime = strtotime("$hrs:$mins", $time);
+        $cutoff_hour = intval($mconfig->an_cutoff_min);
+        $cutoff_min = intval($mconfig->an_cutoff_hour);
+        $cutofftime = strtotime("{$cutoff_hour}:{$cutoff_min}", $time);
         if ($cutofftime < $time) {
-            $cutofftime = strtotime("$hrs:$mins", $time + (24 * 3600));
+            $cutofftime = strtotime("{$cutoff_hour}:{$cutoff_min}", $time + (24 * 3600));
         }
         return $cutofftime;
     }
@@ -98,22 +124,24 @@ class AuthorizeNet
         static $constpd = array();
         require_once($CFG->libdir.'/filelib.php');
 
+        $mconfig = get_config('enrol_authorize');
+
         if (empty($constpd)) {
-            $mconfig = get_config('enrol/authorize');
+            $mconfig = get_config('enrol_authorize');
             $constpd = array(
                 'x_version'         => '3.1',
                 'x_delim_data'      => 'True',
                 'x_delim_char'      => self::AN_DELIM,
                 'x_encap_char'      => self::AN_ENCAP,
                 'x_relay_response'  => 'FALSE',
-                'x_login'           => rc4decrypt($mconfig->an_login)
+                'x_login'           => $mconfig->an_login
             );
 
             if (!empty($mconfig->an_tran_key)) {
-                $constpd['x_tran_key'] = rc4decrypt($mconfig->an_tran_key);
+                $constpd['x_tran_key'] = $mconfig->an_tran_key;
             }
             else {
-                $constpd['x_password'] = rc4decrypt($mconfig->an_password);
+                $constpd['x_password'] = $mconfig->an_password;
             }
         }
 
@@ -141,7 +169,7 @@ class AuthorizeNet
 
         $pd = $constpd;
         $pd['x_method'] = $method;
-        $test = !empty($CFG->an_test);
+        $test = !empty($mconfig->an_test);
         $pd['x_test_request'] = ($test ? 'TRUE' : 'FALSE');
 
         switch ($action) {
@@ -242,8 +270,8 @@ class AuthorizeNet
         }
 
         $headers = array('Connection' => 'close');
-        if (! (empty($CFG->an_referer) || $CFG->an_referer == "http://")) {
-            $headers['Referer'] = $CFG->an_referer;
+        if (! (empty($mconfig->an_referer) || $mconfig->an_referer == "http://")) {
+            $headers['Referer'] = $mconfig->an_referer;
         }
 
         @ignore_user_abort(true);
@@ -251,7 +279,7 @@ class AuthorizeNet
             @set_time_limit(300);
         }
 
-        $host = $test ? 'certification.authorize.net' : 'secure.authorize.net';
+        $host = $test ? 'test.authorize.net' : 'secure.authorize.net';
         $data = download_file_content("https://$host:443/gateway/transact.dll", $headers, $pd, false, 300, 60, true);
         if (!$data) {
             $message = "No connection to https://$host:443";
@@ -333,7 +361,7 @@ class AuthorizeNet
             if ($message == '[[' . $reasonstr . ']]') {
                 $message = isset($response[3]) ? $response[3] : 'unknown error';
             }
-            if ($method == AN_METHOD_CC && !empty($CFG->an_avs) && $response[5] != "P") {
+            if ($method == AN_METHOD_CC && !empty($mconfig->an_avs) && $response[5] != "P") {
                 $avs = "avs" . strtolower($response[5]);
                 $stravs = get_string($avs, "enrol_authorize");
                 $message .= "<br />" . get_string("avsresult", "enrol_authorize", $stravs);
@@ -346,8 +374,13 @@ class AuthorizeNet
                         {
                             if (!empty($cctype)) {
                                 $ccaccepts = get_list_of_creditcards();
+
                                 unset($ccaccepts[$cctype]);
-                                set_config('an_acceptccs', implode(',', array_keys($ccaccepts)));
+                                set_config("an_acceptcc_{$cctype}", 0, 'enrol_authorize');
+
+                                foreach ($ccaccepts as $key=>$val) {
+                                    set_config("an_acceptcc_{$key}", 1, 'enrol_authorize');
+                                }
                                 message_to_admin("$message ($cctype) This is new config(an_acceptccs):", $ccaccepts);
                             }
                             break;
@@ -355,14 +388,14 @@ class AuthorizeNet
                     // Echecks only
                     case self::AN_REASON_ACHONLY:
                         {
-                            set_config('an_acceptmethods', AN_METHOD_ECHECK);
+                            set_config("an_acceptmethod_".AN_METHOD_ECHECK, 1, 'enrol_authorize');
                             message_to_admin("$message This is new config(an_acceptmethods):", array(AN_METHOD_ECHECK));
                             break;
                         }
                     // Echecks aren't accepted
                     case self::AN_REASON_NOACH:
                         {
-                            set_config('an_acceptmethods', AN_METHOD_CC);
+                            set_config("an_acceptmethod_".AN_METHOD_CC, 1, 'enrol_authorize');
                             message_to_admin("$message This is new config(an_acceptmethods):", array(AN_METHOD_CC));
                             break;
                         }
@@ -375,14 +408,15 @@ class AuthorizeNet
                                     // CCD=BUSINESSCHECKING
                                     case 'CCD':
                                         {
-                                            set_config('an_acceptechecktypes', 'CHECKING,SAVINGS');
+                                            set_config('an_acceptecheck_CHECKING', 1, 'enrol_authorize');
+                                            set_config('an_acceptecheck_SAVINGS', 1, 'enrol_authorize');
                                             message_to_admin("$message This is new config(an_acceptechecktypes):", array('CHECKING','SAVINGS'));
                                         }
                                         break;
                                     // WEB=CHECKING or SAVINGS
                                     case 'WEB':
                                         {
-                                            set_config('an_acceptechecktypes', 'BUSINESSCHECKING');
+                                            set_config('an_acceptecheck_BUSINESSCHECKING', 1, 'enrol_authorize');
                                             message_to_admin("$message This is new config(an_acceptechecktypes):", array('BUSINESSCHECKING'));
                                         }
                                         break;
diff --git a/enrol/authorize/db/access.php b/enrol/authorize/db/access.php
index 5ef473c..38a7409 100644
--- a/enrol/authorize/db/access.php
+++ b/enrol/authorize/db/access.php
@@ -2,6 +2,39 @@
 
 $capabilities = array(
 
+    'enrol/authorize:config' => array(
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'manager' => CAP_ALLOW,
+        )
+    ),
+
+    'enrol/authorize:manage' => array(
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'manager' => CAP_ALLOW,
+            'editingteacher' => CAP_ALLOW,
+        )
+    ),
+
+    'enrol/authorize:unenrol' => array(
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'manager' => CAP_ALLOW,
+        )
+    ),
+
+    'enrol/authorize:unenrolself' => array(
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+        )
+    ),
+
+
     'enrol/authorize:managepayments' => array(
         'riskbitmask' => RISK_PERSONAL,
         'captype' => 'write',
diff --git a/enrol/authorize/db/upgrade.php b/enrol/authorize/db/upgrade.php
index a5e9d8f..573e7fa 100644
--- a/enrol/authorize/db/upgrade.php
+++ b/enrol/authorize/db/upgrade.php
@@ -82,7 +82,16 @@ function xmldb_enrol_authorize_upgrade($oldversion) {
         upgrade_plugin_savepoint(true, 2009042700, 'enrol', 'authorize');
     }
 
+    // Add instanceid field to enrol_authorize table
+    if ($oldversion < 2010081203) {
+        $table = new xmldb_table('enrol_authorize');
+        $field = new xmldb_field('instanceid');
+        if (!$dbman->field_exists($table, $field)) {
+            $field->set_attributes(XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, 0, 'userid');
+            $dbman->add_field($table, $field);
+        }
+        upgrade_plugin_savepoint(true, 2010081203, 'enrol', 'authorize');
+    }
+
     return true;
 }
-
-
diff --git a/enrol/authorize/edit.php b/enrol/authorize/edit.php
new file mode 100644
index 0000000..8196969
--- /dev/null
+++ b/enrol/authorize/edit.php
@@ -0,0 +1,95 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Adds new instance of enrol_authorize to specified course
+ * or edits current instance.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require('../../config.php');
+require_once('edit_form.php');
+
+$courseid   = required_param('courseid', PARAM_INT);
+$instanceid = optional_param('id', 0, PARAM_INT); // instanceid
+
+$course = $DB->get_record('course', array('id'=>$courseid), '*', MUST_EXIST);
+$context = get_context_instance(CONTEXT_COURSE, $course->id, MUST_EXIST);
+
+require_login($course);
+require_capability('enrol/authorize:config', $context);
+
+$PAGE->set_url('/enrol/authorize/edit.php', array('courseid'=>$course->id, 'id'=>$instanceid));
+$PAGE->set_pagelayout('admin');
+
+$return = new moodle_url('/enrol/instances.php', array('id'=>$course->id));
+if (!enrol_is_enabled('authorize')) {
+    redirect($return);
+}
+
+$plugin = enrol_get_plugin('authorize');
+
+if ($instanceid) {
+    $instance = $DB->get_record('enrol', array('courseid'=>$course->id, 'enrol'=>'authorize', 'id'=>$instanceid), '*', MUST_EXIST);
+} else {
+    require_capability('moodle/course:enrolconfig', $context);
+    // no instance yet, we have to add new instance
+    navigation_node::override_active_url(new moodle_url('/enrol/instances.php', array('id'=>$course->id)));
+    $instance = new object();
+    $instance->id       = null;
+    $instance->courseid = $course->id;
+}
+
+$mform = new enrol_authorize_edit_form(NULL, array($instance, $plugin, $context));
+
+if ($mform->is_cancelled()) {
+    redirect($return);
+
+} else if ($data = $mform->get_data()) {
+    if ($instance->id) {
+        $instance->status         = $data->status;
+        $instance->name           = $data->name;
+        $instance->cost           = $data->cost;
+        $instance->currency       = $data->currency;
+        //$instance->roleid         = $data->roleid;
+        $instance->enrolperiod    = $data->enrolperiod;
+        $instance->enrolstartdate = $data->enrolstartdate;
+        $instance->enrolenddate   = $data->enrolenddate;
+        $instance->timemodified   = time();
+        $DB->update_record('enrol', $instance);
+
+    } else {
+        $fields = array('status'=>$data->status, 'name'=>$data->name, 'cost'=>$data->cost, 'currency'=>$data->currency,
+                        'enrolperiod'=>$data->enrolperiod, 'enrolstartdate'=>$data->enrolstartdate, 'enrolenddate'=>$data->enrolenddate);
+        $plugin->add_instance($course, $fields);
+    }
+
+    redirect($return);
+}
+
+$PAGE->set_heading($course->fullname);
+$PAGE->set_title(get_string('pluginname', 'enrol_authorize'));
+
+echo $OUTPUT->header();
+echo $OUTPUT->heading(get_string('pluginname', 'enrol_authorize'));
+$mform->display();
+echo $OUTPUT->footer();
diff --git a/enrol/authorize/edit_form.php b/enrol/authorize/edit_form.php
new file mode 100644
index 0000000..d87e56e
--- /dev/null
+++ b/enrol/authorize/edit_form.php
@@ -0,0 +1,99 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Adds new instance of enrol_authorize to specified course
+ * or edits current instance.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+require_once($CFG->libdir.'/formslib.php');
+
+class enrol_authorize_edit_form extends moodleform {
+
+    function definition() {
+        $mform = $this->_form;
+
+        list($instance, $plugin, $context) = $this->_customdata;
+
+        $mform->addElement('header', 'header', get_string('pluginname', 'enrol_authorize'));
+
+        $mform->addElement('text', 'name', get_string('custominstancename', 'enrol'));
+
+        $options = array(ENROL_INSTANCE_ENABLED  => get_string('yes'),
+                         ENROL_INSTANCE_DISABLED => get_string('no'));
+        $mform->addElement('select', 'status', get_string('status', 'enrol_authorize'), $options);
+        $mform->setDefault('status', $plugin->get_config('status'));
+
+        $mform->addElement('text', 'cost', get_string('cost', 'enrol_authorize'), array('size'=>4));
+        $mform->setDefault('cost', $plugin->get_config('cost'));
+
+        $mform->addElement('select', 'currency', get_string('currency', 'enrol_authorize'), get_string_manager()->get_list_of_currencies());
+        $mform->setDefault('currency', $plugin->get_config('currency'));
+
+        if ($instance->id) {
+            $roles = get_default_enrol_roles($context, $instance->roleid);
+        } else {
+            $roles = get_default_enrol_roles($context, $plugin->get_config('roleid'));
+        }
+        $mform->addElement('select', 'roleid', get_string('assignrole', 'enrol_paypal'), $roles);
+        $mform->setDefault('roleid', $plugin->get_config('roleid'));
+
+        $mform->addElement('duration', 'enrolperiod', get_string('enrolperiod', 'enrol_authorize'), array('optional' => true, 'defaultunit' => 86400));
+        $mform->setDefault('enrolperiod', $plugin->get_config('enrolperiod'));
+
+        $mform->addElement('date_selector', 'enrolstartdate', get_string('enrolstartdate', 'enrol_authorize'), array('optional' => true));
+        $mform->setDefault('enrolstartdate', 0);
+
+        $mform->addElement('date_selector', 'enrolenddate', get_string('enrolenddate', 'enrol_authorize'), array('optional' => true));
+        $mform->setDefault('enrolenddate', 0);
+
+        $mform->addElement('hidden', 'id');
+        $mform->addElement('hidden', 'courseid');
+
+        $this->add_action_buttons(true, ($instance->id ? null : get_string('addinstance', 'enrol')));
+
+        $this->set_data($instance);
+    }
+
+    function validation($data, $files) {
+        global $DB, $CFG;
+        $errors = parent::validation($data, $files);
+
+        list($instance, $plugin, $context) = $this->_customdata;
+
+        if ($data['status'] == ENROL_INSTANCE_ENABLED) {
+            if (!empty($data['enrolenddate']) and $data['enrolenddate'] < $data['enrolstartdate']) {
+                $errors['enrolenddate'] = get_string('enrolenddaterror', 'enrol_authorize');
+            }
+
+            if (!is_numeric($data['cost'])) {
+                $errors['cost'] = get_string('costerror', 'enrol_authorize');
+
+            }
+        }
+
+        return $errors;
+    }
+}
diff --git a/enrol/authorize/enrol_form.php b/enrol/authorize/enrol_form.php
index 9edf255..e30ea09 100755
--- a/enrol/authorize/enrol_form.php
+++ b/enrol/authorize/enrol_form.php
@@ -1,16 +1,44 @@
 <?php
 
-if (!defined('MOODLE_INTERNAL')) {
-    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
-}
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize.Net enrol plugin implementation.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
 
 require_once($CFG->libdir.'/formslib.php');
 
 class enrol_authorize_form extends moodleform
 {
-    function definition()
-    {
-        global $CFG, $USER;
+    protected $instance;
+
+    function definition() {
+        global $USER;
+
+        $mform = $this->_form;
+        $this->instance = $this->_customdata;
+        $plugin = enrol_get_plugin('authorize');
 
         $paymentmethodsenabled = get_list_of_payment_methods();
         $paymentmethod = optional_param('paymentmethod', $paymentmethodsenabled[0], PARAM_ALPHA);
@@ -18,30 +46,27 @@ class enrol_authorize_form extends moodleform
             print_error('invalidpaymentmethod', '', '', $paymentmethod);
         }
 
-        $mform =& $this->_form;
-        $course = $this->_customdata['course'];
-
-        $mform->addElement('header', 'general', get_string('paymentrequired'));
         $othermethodstr = $this->other_method_available($paymentmethod);
         if ($othermethodstr) {
             $mform->addElement('static', '', '<div class="mdl-right">' . $othermethodstr . '</div>', '');
         }
 
-        $mform->addElement('hidden', 'id', $course->id);
+        $mform->addElement('hidden', 'id');
         $mform->setType('id', PARAM_INT);
+        $mform->setDefault('id', $this->instance->courseid);
+
+        $mform->addElement('hidden', 'instanceid');
+        $mform->setType('instanceid', PARAM_INT);
+        $mform->setDefault('instanceid', $this->instance->id);
 
         $mform->addElement('hidden', 'paymentmethod', $paymentmethod);
         $mform->setType('paymentmethod', PARAM_ALPHA);
 
         $firstlastnamestr = (AN_METHOD_CC == $paymentmethod) ? get_string('nameoncard', 'enrol_authorize') : get_string('echeckfirslasttname', 'enrol_authorize');
-        $firstlastnamegrp = array();
-        $firstlastnamegrp[] = &$mform->createElement('text', 'firstname', '', 'size="16"');
-        $firstlastnamegrp[] = &$mform->createElement('text', 'lastname', '', 'size="16"');
-        $mform->addGroup($firstlastnamegrp, 'firstlastgrp', $firstlastnamestr, '&nbsp;', false);
-        $firstlastnamegrprules = array();
-        $firstlastnamegrprules['firstname'][] = array(get_string('missingfirstname'), 'required', null, 'client');
-        $firstlastnamegrprules['lastname'][] = array(get_string('missinglastname'), 'required', null, 'client');
-        $mform->addGroupRule('firstlastgrp', $firstlastnamegrprules);
+        $mform->addElement('text', 'firstname', get_string('firstnameoncard', 'enrol_authorize'), 'size="16"');
+        $mform->addElement('text', 'lastname', get_string('lastnameoncard', 'enrol_authorize'), 'size="16"');
+        $mform->addRule('firstname', get_string('missingfirstname'), 'required', null, 'client');
+        $mform->addRule('lastname', get_string('missinglastname'), 'required', null, 'client');
         $mform->setType('firstname', PARAM_ALPHANUM);
         $mform->setType('lastname', PARAM_ALPHANUM);
         $mform->setDefault('firstname', $USER->firstname);
@@ -66,14 +91,10 @@ class enrol_authorize_form extends moodleform
             for ($i = $startyear; $i < $endyear; $i++) {
                 $yearsmenu[$i] = $i;
             }
-            $ccexpiregrp = array();
-            $ccexpiregrp[] = &$mform->createElement('select', 'ccexpiremm', '', $monthsmenu);
-            $ccexpiregrp[] = &$mform->createElement('select', 'ccexpireyyyy', '', $yearsmenu);
-            $mform->addGroup($ccexpiregrp, 'ccexpiregrp', get_string('ccexpire', 'enrol_authorize'), '&nbsp;', false);
-            $ccexpiregrprules = array();
-            $ccexpiregrprules['ccexpiremm'][] = array(get_string('missingccexpire', 'enrol_authorize'), 'required', null, 'client');
-            $ccexpiregrprules['ccexpireyyyy'][] = array(get_string('missingccexpire', 'enrol_authorize'), 'required', null, 'client');
-            $mform->addGroupRule('ccexpiregrp', $ccexpiregrprules);
+            $mform->addElement('select', 'ccexpiremm', get_string('expiremonth', 'enrol_authorize'), $monthsmenu);
+            $mform->addElement('select', 'ccexpireyyyy', get_string('expireyear', 'enrol_authorize'), $yearsmenu);
+            $mform->addRule('ccexpiremm', get_string('missingccexpiremonth', 'enrol_authorize'), 'required', null, 'client');
+            $mform->addRule('ccexpireyyyy', get_string('missingccexpireyear', 'enrol_authorize'), 'required', null, 'client');
             $mform->setType('ccexpiremm', PARAM_INT);
             $mform->setType('ccexpireyyyy', PARAM_INT);
             $mform->setDefault('ccexpiremm', '');
@@ -91,7 +112,7 @@ class enrol_authorize_form extends moodleform
             $mform->addRule('cvv', get_string('missingcvv', 'enrol_authorize'), 'required', null, 'client');
             $mform->addRule('cvv', get_string('missingcvv', 'enrol_authorize'), 'numeric', null, 'client');
 
-            if (!empty($CFG->an_authcode)) {
+            if ($plugin->get_config('an_authcode')) {
                 $ccauthgrp = array();
                 $ccauthgrp[] = &$mform->createElement('checkbox', 'haveauth', null, get_string('haveauthcode', 'enrol_authorize'));
                 $ccauthgrp[] = &$mform->createElement('static', 'nextline', null, '<br />');
@@ -105,7 +126,7 @@ class enrol_authorize_form extends moodleform
                 $mform->setDefault('ccauthcode', '');
             }
 
-            if (!empty($CFG->an_avs)) {
+            if ($plugin->get_config('an_avs')) {
                 $mform->addElement('header', '', '&nbsp;&nbsp;' . get_string('address'), '');
 
                 $mform->addElement('text', 'ccaddress', get_string('address'), 'size="30"');
@@ -113,14 +134,9 @@ class enrol_authorize_form extends moodleform
                 $mform->setDefault('ccaddress', $USER->address);
                 $mform->addRule('ccaddress', get_string('missingaddress', 'enrol_authorize'), 'required', null, 'client');
 
-                $citystategrp = array();
-                $citystategrp[] = &$mform->createElement('text', 'cccity', '', 'size="14"');
-                $citystategrp[] = &$mform->createElement('static', 'sep', null, ' - ');
-                $citystategrp[] = &$mform->createElement('text', 'ccstate', '', 'size="8"');
-                $mform->addGroup($citystategrp, 'citystategrp', get_string('city') . ' - ' . get_string('state'), '&nbsp;', false);
-                $citystategrprules = array();
-                $citystategrprules['cccity'][] = array(get_string('missingcity'), 'required', null, 'client');
-                $mform->addGroupRule('citystategrp', $citystategrprules);
+                $mform->addElement('text', 'cccity', get_string('cccity', 'enrol_authorize'), 'size="14"');
+                $mform->addElement('text', 'ccstate', get_string('ccstate', 'enrol_authorize'), 'size="8"');
+                $mform->addRule('cccity', get_string('missingcity'), 'required', null, 'client');
                 $mform->setType('cccity', PARAM_ALPHANUM);
                 $mform->setType('ccstate', PARAM_ALPHANUM);
                 $mform->setDefault('cccity', $USER->city);
@@ -142,9 +158,7 @@ class enrol_authorize_form extends moodleform
                 $mform->setType('ccountry', PARAM_ALPHA);
                 $mform->setDefault('cccountry', $USER->country);
             }
-        }
-        elseif (AN_METHOD_ECHECK == $paymentmethod)
-        {
+        } elseif (AN_METHOD_ECHECK == $paymentmethod) {
             $mform->addElement('text', 'abacode', get_string('echeckabacode', 'enrol_authorize'), 'size="9" maxlength="9"');
             $mform->setType('abacode', PARAM_ALPHANUM);
             $mform->setDefault('abacode', '');
@@ -182,10 +196,9 @@ class enrol_authorize_form extends moodleform
         $this->add_action_buttons(false, get_string('sendpaymentbutton', 'enrol_authorize'));
     }
 
-    function validation($data, $files)
-    {
-        global $CFG;
+    function validation($data, $files) {
         $errors = parent::validation($data, $files);
+        $plugin = enrol_get_plugin('authorize');
 
         if (AN_METHOD_CC == $data['paymentmethod'])
         {
@@ -197,14 +210,14 @@ class enrol_authorize_form extends moodleform
             $validcc = $this->validate_cc($data['cc'], $data['cctype'], $expdate);
             if (!$validcc) {
                 if ($validcc === 0) {
-                    $errors['ccexpiregrp'] = get_string('ccexpired', 'enrol_authorize');
+                    $errors['ccexpiremm'] = get_string('ccexpired', 'enrol_authorize');
                 }
                 else {
                     $errors['cc'] = get_string('ccinvalid', 'enrol_authorize');
                 }
             }
 
-            if (!empty($CFG->an_authcode) && !empty($data['haveauth']) && empty($data['ccauthcode'])) {
+            if ($plugin->get_config('an_authcode') && !empty($data['haveauth']) && empty($data['ccauthcode'])) {
                 $errors['ccauthgrp'] = get_string('missingccauthcode', 'enrol_authorize');
             }
         }
@@ -224,16 +237,14 @@ class enrol_authorize_form extends moodleform
 
     private function other_method_available($currentmethod)
     {
-        $course = $this->_customdata['course'];
 
         if ($currentmethod == AN_METHOD_CC) {
             $otheravailable = in_array(AN_METHOD_ECHECK, get_list_of_payment_methods());
-            $url = 'enrol.php?id='.$course->id.'&amp;paymentmethod='.AN_METHOD_ECHECK;
+            $url = 'index.php?id='.$this->instance->courseid.'&amp;paymentmethod='.AN_METHOD_ECHECK;
             $stringtofetch = 'usingecheckmethod';
-        }
-        else {
+        } else {
             $otheravailable = in_array(AN_METHOD_CC, get_list_of_payment_methods());
-            $url = 'enrol.php?id='.$course->id.'&amp;paymentmethod='.AN_METHOD_CC;
+            $url = 'index.php?id='.$this->instance->courseid.'&amp;paymentmethod='.AN_METHOD_CC;
             $stringtofetch = 'usingccmethod';
         }
         if ($otheravailable) {
diff --git a/enrol/authorize/import_form.php b/enrol/authorize/import_form.php
index c43123f..3af46d4 100644
--- a/enrol/authorize/import_form.php
+++ b/enrol/authorize/import_form.php
@@ -15,6 +15,18 @@
 // You should have received a copy of the GNU General Public License
 // along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 
+/**
+ * Adds new instance of enrol_authorize to specified course
+ * or edits current instance.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+
 require_once($CFG->libdir.'/formslib.php');
 
 class enrol_authorize_import_form extends moodleform {
diff --git a/enrol/authorize/index.php b/enrol/authorize/index.php
index 3fd83a8..5bdee18 100644
--- a/enrol/authorize/index.php
+++ b/enrol/authorize/index.php
@@ -1,5 +1,32 @@
 <?php
 
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Adds new instance of enrol_authorize to specified course
+ * or edits current instance.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+
 /// Load libraries
     require_once('../../config.php');
     require_once('const.php');
